;This program write colored text on screen, to relevant video buffer
;-prints character CHAR in COLOR color NUM of times
;-demonstrates the use of video buffer (text) to print text (with color)
;-demonstrates use of STOSW instruction for iteration (looping)

.model small
.stack 100h

.code
NUM     EQU 4000
CHAR    EQU 'G'
COLOR   EQU 4                   ;4=red

start:  mov ah,0                ;function: set video mode
        mov al,3h               ;3=text mode
        int 10h

        mov ax,0b800h           ;video buffer (color text) segment
        mov es,ax               ;save segment address to ES
        xor di,di               ;clear DI, ES:DI points to video buffer

        mov ah,COLOR            ;color attribute
        mov al,CHAR             ;character to store
                                ;AX=AH:AL will be saved to the video buffer
        mov cx,NUM              ;REP will repeat CX times
        cld                     ;clear direction flag, select forward direction
        rep stosw               ;repeat CX times, store AX to ES:DI, increment DI

        mov ax,4c00h            ;function: exit to DOS
        int 21h

;TASK:
;1. TRY WITH DIFFERENT NUMBER/CHARACTER FOR NUM,CHAR,COLOR VARIABLES
;2. Can we use "mov di,0" instead of "xor di,di"?  Which is prefered and why?
;3. EDIT THE PROGRAM TO ALLOW USER TO CHOOSE THE CHARACTER, COLOR AND NUM

end

