;This program draw colored pixel on screen, using INT 10H functions
;-draws a diagonal line from top-left conner to a length LEN in COLOR color
;-demonstrates the use of video functions in INT 10H to draw pixel (using coordinate system)
;-demonstrates decision making by use of CMP,JMP,JE,JNE instructions
;-demonstrates saving and restoring original video mode
;-demonstrates checking ESC to exit program

.model medium
.stack 300h                     ;stack size

.code
LEN     EQU 100                 ;length of the line drawn
COLOR	EQU 6			;6=brown

start:  mov ah,0fh              ;function: get current video mode
        int 10h

        mov vidMode,al          ;store current video mode

        mov ah,00h              ;function: set video mode
        mov al,10h              ;to 640x350 VGA 16 color graphics
        int 10h

        mov ah,0bh              ;function: set background/pallete color
        mov bh,00h              ;select background to set (0=bg,1=pallete)
        mov bl,01h              ;select color value 01=blue
        int 10h

        mov cx,0                ;starting column at 0=left most (0-639)
        mov dx,0                ;starting row at 0=top most (0-349)
again:
        mov ah,0ch              ;function: write graphic pixel at coordinate (cx,dx)
        mov al,COLOR            ;color of pixel

        int 10h

        inc cx                  ;next column
        inc dx                  ;next row
                                ;effective (cx,dx) move diagonally downward
        cmp dx,LEN              ;length to draw

        jne again               ;if not yet up to the length, repeat

        mov ah,08h              ;function: read character without echo
        int 21h

        cmp al,01bh             ;compare if character is 01bh=ESC
        je ending               ;if ESC pressed, exit

        xor cx,cx               ;clear cx (column number)
        xor dx,dx               ;clear dx (row number)
        jmp again               ;if other key, repeat draw
ending:
        mov ah,00h              ;function: set video mode
        mov al,vidMode          ;restore to initial mode
        int 10h

        mov ax,4c00h            ;function: exit to DOS
        int 21h

.data
vidMode db 10h

;TASKS:
;1. TRY WITH DIFFERENT NUMBER FOR COLOR AND LEN
;2. EDIT THE PROGRAM TO ALLOW USER TO CHANGE COLOR AND LEN
;3. EDIT THE PROGRAM TO USE "STOSB" INSTRUCTION IN PLACE OF THE CMP,JNE
;4. EDIT THE PROGRAM TO GET THE LINE TO CONTINUE DRAWING FOR LENGTH

end

