;This program write colored text on screen, to relevant video buffer
;-prints character CHAR in COLOR for NUM times
;-demonstrates the use of video buffer (text) to print text (with color)
;-demonstrates the use of LOOP instruction for iterations (looping)
;-extends the TEXT.ASM to demonstrate use of LOOP instruction to fill screen

.model medium
.stack 200h

.code
CHAR    EQU 23h                 ;23h='#'
COLOR   EQU 1                   ;1=blue
NUM     EQU 10                  ;number of times to repeat the character

start:  mov ah,0                ;function: set video mode
        mov al,3h               ;3=text mode
        int 10h

        mov bx,0b800h           ;video buffer (color text) segment
        mov es,bx               ;save segment address to ES
        
        mov bx,0                ;video buffer starts at 0
        mov ah,CHAR             ;character attribute
        mov al,COLOR            ;color attribute

        mov cx,NUM              ;loop counter
loop1:
        mov es:[bx],ah          ;first byte is character attribute
        inc bx                  ;point to next byte
        mov es:[bx],al          ;second byte is color attribute
        inc bx                  ;point to next byte (1st byte of next char)

        loop loop1              ;loop loop1 for cx times

        mov ax,0100h            ;function: read character from standard input, with echo
        int 21h                 ;just a prompt/pause

        mov ax,4c00h            ;function: exit to DOS
        int 21h

;TASK:
;1. TRY WITH DIFFERENT VALUES FOR CHAR,COLOR,NUM VARIABLES
;2. EDIT THE PROGRAM TO ALLOW USER TO CHOOSE THE CHARACTER, COLOR, NUM

end

