;This program draw colored pixel on screen, using INT 10H functions
;-draws/paints the screen with colored pixel
;-demonstrates the use of video buffer (graphic) to color each pixel on screen
;-demonstrates use of LOOP instruction for iteration (looping)

.model small
.stack 100h                     ;stack size

.code
SSIZE   EQU 64000               ;total pixels, for mode 13h is 320x200
COLOR	EQU 6			;6=brown

start:  mov ah,00h              ;function: set video mode
        mov al,13h              ;13=320x200 VGA 256 color graphics
        int 10h

        mov bx,0a000h           ;video buffer (graphic) segment
        mov es,bx               ;save segment address to ES
                                ;in graphic mode, video buffer starts at 0a000h
                                ;every 1 byte (color) prints a pixel
                                ;from left-top corner

        mov bx,0                ;first pixel location
        mov ah,COLOR            ;color attribute

        mov cx,SSIZE            ;screen size (total pixels) as loop counter
loop1:
        mov es:[bx],ah          ;print 1 pixel
        inc bx                  ;point to next pixel (next location in buffer)
        loop loop1              ;print cx number of pixels

        mov ax,100h             ;function: read character from standard input, with echo
        int 21h                 ;just a prompt/pause

        mov ax,4c00h            ;function: exit to DOS
        int 21h


;TASKS:
;1. TRY WITH DIFFERENT NUMBER FOR COLOR
;2. EDIT THE PROGRAM TO ALLOW USER TO CHANGE COLOR
;3. EDIT THE PROGRAM TO USE "STOSB" INSTRUCTION TO DO LOOPING
;4. YOUR SCREEN IS MESSED UP AFTER YOUR PROGRAM, AS YOU HAVE CHANGED
;   THE VIDEO MODE FROM TEXT (DOS) TO GRAPHICS, FIX THIS PROBLEM

end

