;This program write colored text on screen, to relevant video buffer
;-prints character CHAR in COLOR
;-demonstrates the use of video buffer (text) to print text (with color)

.model small
.stack 100h

.code
CHAR    EQU 23h                 ;23h='#'
COLOR   EQU 1                   ;1=blue

start:  mov ah,0                ;function: set video mode
        mov al,3h               ;3=text mode
        int 10h
                                ;in text mode, the screen is 80x25 size

        mov bx,0b800h           ;video buffer (color text) segment
        mov es,bx               ;save segment address to ES
                                ;in text mode, video buffer starts at 0b800h
                                ;every 2 bytes (char,color) print a character
                                ;from left-top position
        
        mov bx,0                ;video buffer starts at 0
        mov ah,CHAR             ;first byte is character attribute
        mov es:[bx],ah
        inc bx                  ;point to next byte
        mov ah,COLOR            ;second byte is color attribute
        mov es:[bx],ah
                                ;the above print 1 colored character
                                ;at left-top position, 1st position
                                ;the next 2 bytes in video buffe will
                                ;print the next colored character

        mov ax,0100h            ;function: read character from standard input, with echo
        int 21h                 ;just a prompt/pause

        mov ax,4c00h            ;function: exit to DOS
        int 21h

;TASK:
;1. TRY WITH DIFFERENT VALUES FOR CHAR,COLOR VARIABLES
;2. EDIT THE PROGRAM TO ALLOW USER TO CHOOSE THE CHARACTER, COLOR

end

